#ifndef __TINTERACTION_H
#define __TINTERACTION_H
#include "TInteraction.h"
#endif



using namespace std;

//
//   Class TTable:
// ==============================================

TTable::TTable()
{

}
//---------
TTable::TTable(const char *file_name)
{
  ifstream file(file_name, ios::in);
  double energy, range, rangestraggling, stopping;
  string line;
  string Zproj = "Zproj";
  string Aproj = "Aproj";
  string Ztgt = "Ztgt";
  string eq = "=";
  string value;
  string::size_type pos;
  string::size_type start_pos;
  
  fEnergy.clear();                      //clearing all vectors
  fRange.clear();                       //clearing all vectors
  fRangeStraggling.clear();             //clearing all vectors
  fStoppingPower.clear();
  

  while (!file.eof())
    {     
      getline(file,line);
      if (line[0] == '#')
	{	 
	  //cout << line << endl;
	  pos = line.find(Zproj,1);
	  if (pos != string::npos)   //! found Zproj  !
	    {
	      start_pos = line.find(eq,pos);
	      if (start_pos != string::npos)
		{
		  value = line.substr(start_pos+1, 4);
		  //cout << "number: "<< atoi(value.c_str()) << endl;
		  fZ = (UInt_t)atoi(value.c_str());
		}	      
	    }
	  pos = line.find(Aproj,1);
	  if (pos != string::npos)   //! found Aproj  !
	    {
	      start_pos = line.find(eq,pos);
	      if (start_pos != string::npos)
		{
		  value = line.substr(start_pos+1, 4);
		  //cout << "number: "<< atoi(value.c_str()) << endl;
		  fA = (UInt_t)atoi(value.c_str());
		}	      
	    }
	  pos = line.find(Ztgt,1);
	  if (pos != string::npos)   //! found Ztgt  !
	    {
	      start_pos = line.find(eq,pos);
	      if (start_pos != string::npos)
		{
		  value = line.substr(start_pos+1, 4);
		  //cout << "number: "<< atoi(value.c_str()) << endl;
		  fZtgt = (UInt_t)atoi(value.c_str());
		}	      
	    }
	    
	}
      else
	{
	  file >> energy >> range >> rangestraggling >> stopping;
	  fEnergy.push_back(energy);
	  fRange.push_back(range);
	  fRangeStraggling.push_back(rangestraggling);
	  fStoppingPower.push_back(stopping);
	}
    }
  file.close();
}
//=-------------------
TTable::~TTable()
{
  fEnergy.clear();
  fRange.clear();
  fRangeStraggling.clear();
  fStoppingPower.clear();

}
//----------------------
void TTable::Init(const char *file_name)
{
  ifstream file(file_name, ios::in);
  double energy, range, rangestraggling, stopping;
  string line;
  string Zproj = "Zproj";
  string Aproj = "Aproj";
  string Ztgt = "Ztgt";
  string eq = "=";
  string value;
  string::size_type pos;
  string::size_type start_pos;
  
  fEnergy.clear();                      //clearing all verctors
  fRange.clear();                       //clearing all verctors
  fRangeStraggling.clear();             //clearing all verctors
  fStoppingPower.clear();
  

  while (!file.eof())
    {     
      getline(file,line);
      if (line[0] == '#')
	{	 
	  //cout << line << endl;
	  pos = line.find(Zproj,1);
	  if (pos != string::npos)   //! found Zproj  !
	    {
	      start_pos = line.find(eq,pos);
	      if (start_pos != string::npos)
		{
		  value = line.substr(start_pos+1, 4);
		  //cout << "number: "<< atoi(value.c_str()) << endl;
		  fZ = (UInt_t)atoi(value.c_str());
		}	      
	    }
	  pos = line.find(Aproj,1);
	  if (pos != string::npos)   //! found Aproj  !
	    {
	      start_pos = line.find(eq,pos);
	      if (start_pos != string::npos)
		{
		  value = line.substr(start_pos+1, 4);
		  //cout << "number: "<< atoi(value.c_str()) << endl;
		  fA = (UInt_t)atoi(value.c_str());
		}	      
	    }
	  pos = line.find(Ztgt,1);
	  if (pos != string::npos)   //! found Ztgt  !
	    {
	      start_pos = line.find(eq,pos);
	      if (start_pos != string::npos)
		{
		  value = line.substr(start_pos+1, 4);
		  //cout << "number: "<< atoi(value.c_str()) << endl;
		  fZtgt = (UInt_t)atoi(value.c_str());
		}	      
	    }
	    
	}
      else
	{
	  file >> energy >> range >> rangestraggling >> stopping;
	  fEnergy.push_back((Double_t)energy);
	  fRange.push_back((Double_t)range);
	  fRangeStraggling.push_back((Double_t)rangestraggling);
	  fStoppingPower.push_back(stopping);
	}
    }
  file.close();
}
//---------------------
UInt_t TTable::Size()
{
  return (UInt_t)fEnergy.size();
}
//-----------------
Int_t TTable::FindEnergy(Double_t energy)
{
  // function return -1 if energy is out of range < less
  // and returns N (Size) if energy is out of range > more
  Int_t i_u, i_l, i_m;    //upper and lower limits
  Int_t N = fEnergy.size();
  Bool_t ascnd;       //ascending check


  i_u = N;    //initialization of upper limit
  i_l = -1;   // initialization of lower limit
  ascnd = (fEnergy[N-1] >= fEnergy[0]);
  while(i_u - i_l > 1)
    {
      i_m = (i_u + i_l) >> 1;
      if (energy >= fEnergy[i_m] == ascnd)
	i_l = i_m;
      else
	i_u = i_m;
    }
  if (energy == fEnergy[0])
    return 0;
  else 
    if (energy == fEnergy[N-1])
      return N-2;
    else
      return i_l;
}
//----------------
Double_t *TTable::GetEnergy(UInt_t index, UInt_t n)
{
  Double_t *error = 0;
  if (index >= 0 && index < fEnergy.size() && n>1 && (n%2) == 1)  
    {
      Double_t *result = new Double_t[n];
      UInt_t n_2 = n >> 1;
      UInt_t count = 0;
      if ((index - n_2) < 0) 
	return error;
      for (UInt_t i=(index-n_2); i<=(index+n_2); i++)
	{
	  result[count] = fEnergy[i];
	  count++;
	}
      return result;
    }
  else
    return error;   //index is out of scale!!!
}
Double_t *TTable::GetRange(UInt_t index, UInt_t n)
{
  Double_t *error = 0;
  if (index >= 0 && index < fEnergy.size() && n>1 && (n%2) == 1)  
    {
      Double_t *result = new Double_t[n];
      UInt_t n_2 = n >> 1;
      UInt_t count = 0;
      if ((index - n_2) < 0) 
	return error;
      for (UInt_t i=(index-n_2); i<=(index+n_2); i++)
	{
	  result[count] = fRange[i];
	  count++;
	}
      return result;
    }
  else
    return error;   //index is out of scale!!!
}
Double_t *TTable::GetRangeStraggling(UInt_t index, UInt_t n)
{
  Double_t *error = 0;
  if (index >= 0 && index < fEnergy.size() && n>1)  
    {
      Double_t *result = new Double_t[n];
      UInt_t n_2 = n >> 1;
      UInt_t count = 0;
      if ((index - n_2) < 0) 
	return error;
      for (UInt_t i=(index-n_2); i<=(index+n_2); i++)
	{
	  result[count] = fRangeStraggling[i];
	  count++;
	}
      return result;
    }
  else
    return error;   //index is out of scale!!!
}
//------------------
Double_t *TTable::GetStoppingPower(UInt_t index, UInt_t n)
{
  Double_t *error = 0;
  if (index >= 0 && index < fEnergy.size() && n>1 && (n%2) == 1)  
    {
      Double_t *result = new Double_t[n];
      UInt_t n_2 = n >> 1;
      UInt_t count = 0;
      if ((index - n_2) < 0) 
	return error;
      for (UInt_t i=(index-n_2); i<=(index+n_2); i++)
	{
	  result[count] = fStoppingPower[i];
	  count++;
	}
      return result;
    }
  else
    return error;   //index is out of scale!!!
}
//------------------
void TTable::Dump(UInt_t index)
{
   if (index >= 0 && index < fEnergy.size())
    {      
      cout << "************  Contents of TTable object:   **********\n";
      cout << "Fragment A: " << fA << "   Z: " << fZ << endl;
      cout << "Target   Z: " << fZtgt << "   Option: " << fOption << endl;
      cout << "Energy\t Range\t RangeStraggling\n";
      cout << fEnergy[index] << "\t" << fRange[index] << "\t" << fRangeStraggling[index]<<endl;
      cout << "*****************************************************\n";
    }
   else
     cout << "Index is out of range!\n";
}
//----------------------------------
Int_t TTable::FindRange(Double_t range)
{
  // function return -1 if energy is out of range < less
  // and returns N-1  if range is out of range > more
  Int_t i_u, i_l, i_m;    //upper and lower limits
  Int_t N = fRange.size();
  Bool_t ascnd;       //ascending check


  i_u = N;    //initialization of upper limit
  i_l = -1;   // initialization of lower limit
  ascnd = (fRange[N-1] >= fRange[0]);
  while(i_u - i_l > 1)
    {
      i_m = (i_u + i_l) >> 1;
      if (range >= fRange[i_m] == ascnd)
	i_l = i_m;
      else
	i_u = i_m;
    }
  if (range == fRange[0])
    return 0;
  else 
    if (range == fRange[N-1])
      return N-2;
    else
      return i_l;
}
//------------------------
Int_t TTable::FindRangeStraggling(Double_t straggling)
{
  // function return -1 if energy is out of range < less
  // and returns N-1  if range is out of range > more
  Int_t i_u, i_l, i_m;    //upper and lower limits
  Int_t N = fRangeStraggling.size();
  Bool_t ascnd;       //ascending check


  i_u = N;    //initialization of upper limit
  i_l = -1;   // initialization of lower limit
  ascnd = (fRangeStraggling[N-1] >= fRangeStraggling[0]);
  while(i_u - i_l > 1)
    {
      i_m = (i_u + i_l) >> 1;
      if (straggling >= fRangeStraggling[i_m] == ascnd)
	i_l = i_m;
      else
	i_u = i_m;
    }
  if (straggling == fRangeStraggling[0])
    return 0;
  else 
    if (straggling == fRangeStraggling[N-1])
      return N-2;
    else
      return i_l;
}
//------------------------
Int_t TTable::FindStoppingPower(Double_t stoppingpower)
{
  // function return -1 if energy is out of range < less
  // and returns N-1  if range is out of range > more
  Int_t i_u, i_l, i_m;    //upper and lower limits
  Int_t N = fStoppingPower.size();
  Bool_t ascnd;       //ascending check


  i_u = N;    //initialization of upper limit
  i_l = -1;   // initialization of lower limit
  ascnd = (fStoppingPower[N-1] >= fStoppingPower[0]);
  while(i_u - i_l > 1)
    {
      i_m = (i_u + i_l) >> 1;
      if (stoppingpower >= fStoppingPower[i_m] == ascnd)
	i_l = i_m;
      else
	i_u = i_m;
    }
  if (stoppingpower == fStoppingPower[0])
    return 0;
  else 
    if (stoppingpower == fStoppingPower[N-1])
      return N-2;
    else
      return i_l;
}
//------------------
TTable TTable::operator=(const TTable &rhs)
{
  fA = rhs.fA;
  fZ = rhs.fZ;
  fZtgt = rhs.fZtgt;
  fOption = rhs.fOption;

  fEnergy.clear();
  fRange.clear();
  fRangeStraggling.clear();
  fStoppingPower.clear();

  for (UInt_t i=0; i<rhs.fEnergy.size(); i++)
    {
      fEnergy.push_back(rhs.fEnergy[i]);
      fRange.push_back(rhs.fRange[i]);
      fRangeStraggling.push_back(rhs.fRangeStraggling[i]);
      fStoppingPower.push_back(rhs.fStoppingPower[i]);
    }
  return *this;
}
//=============================================================
//
// Class TSpline functions:
//
//=============================================================
TSpline::TSpline(const TTable &table)
{
  fTable = table;
}
//----
TSpline::TSpline(TTable *table)
{
  fTable = *table;
}
//----------
TSpline::~TSpline()
{
  fDataX.clear();
  fDataY.clear();
}
//----------------
void TSpline::PolInterpolate(const Double_t x, Double_t &y, Double_t &dy)
{
  // function copied from Numerical Recipes in C++ (W.H. Press) page (113)
  // ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  // interpolate fDataX and fDataY vectors!
  if (fDataX.size() > 0 && fDataY.size() > 0 && fDataX.size() == fDataY.size())
    {
      Int_t i,m,ns=0;
      Double_t den, dif, dift, ho, hp, w;
      
      Int_t n=fDataX.size();
      Double_t *c = new Double_t[n];
      Double_t *d = new Double_t[n];
      dif = fabs(x - fDataX[0]);
      for (i=0; i<n; i++)
	{
	  if ((dift = fabs(x-fDataX[i])) < dif)
	    {
	      ns = i;
	      dif = dift;
	    }
	  c[i] = fDataY[i];
	  d[i] = fDataY[i];	  
	}
      y = fDataY[ns--];
      for (m=1; m<n; m++)
	{
	  for (i=0; i<n-m; i++)
	    {
	      ho = fDataX[i] - x;
	      hp = fDataX[i+m] - x;
	      w = c[i+1] - d[i];
	      if ((den = ho-hp) == 0)
		cerr << "Error in function PolInterpolate\n";
	      den = w/den;
	      d[i] = hp*den;
	      c[i] = ho*den;
	    }
	  y += (dy=(2*(ns+1) < (n-m) ? c[ns+1] : d[ns--]));
	}
      
      return;
    }
  else
    {
      cerr << "Problem with fDataX and/or fDataY!!!  in function PolInterploate\n";
      return;
    }
}
//------------------------
Double_t TSpline::EnergyLoss(Double_t energy, Double_t thickness)
{
  // first of all we need to find energy in the table:
  UInt_t order = 3;   //plynomial order
  Double_t range, d_range;
  Double_t energy_after, d_energy_after;
  Int_t E_index, R_index;   //index of energy and range respectively
  Double_t *x = new Double_t[order];
  Double_t *y = new Double_t[order];
    
  fDataX.clear();
  fDataY.clear();
  
  E_index = fTable.FindEnergy(energy);
  x = fTable.GetEnergy(E_index, order);
  y = fTable.GetRange(E_index, order);
  
  if (x != 0 && x != 0)
    {
      for (UInt_t i=0; i<order; i++)
	{
	  fDataX.push_back(x[i]);
	  fDataY.push_back(y[i]);
	}
      this->PolInterpolate(energy, range, d_range);
      //cout << "Range is: " << range << "  Error is: " << d_range<< " Index: " << E_index<< endl;
      //cout << " Range at index: " << fDataY[2] << " Energy is : " << fDataX[2] << endl;
      if ((range-thickness) <= 0)   // <<--- particle is stopped in the material
	return 0;
      else
	{
	  R_index = fTable.FindRange(range-thickness);
	  delete x, y;
	  Double_t *x = new Double_t[order];
	  Double_t *y = new Double_t[order];
	  x = fTable.GetRange(R_index, order);
	  y = fTable.GetEnergy(R_index, order);
	  fDataX.clear();
	  fDataY.clear();
	  if (x != 0 && y != 0)
	    {
	      for (UInt_t k=0; k<order; k++)
		{		    
		  fDataX.push_back(x[k]);
		  fDataY.push_back(y[k]);
		}
	      this->PolInterpolate(range-thickness, energy_after, d_energy_after);
	      //cout << "Energy is: " << energy_after << "  Error is: " << d_energy_after<< " Index: " << R_index<<endl;
	      //cout << " Energy at index: " << fDataY[2] << " Range is : " << fDataX[2] << endl;
	      return energy_after;
	    }
	  else
	    return -777;
	}		  		           
    }
  else
    return -777;
}
//--------------------------
Double_t TSpline::RangeInMatter(Double_t energy)
{
    // first of all we need to find energy in the table:
  UInt_t order = 3;
  Double_t range, d_range;
  Int_t E_index;   //index of energy and range respectively
  Double_t *x = new Double_t[order];
  Double_t *y = new Double_t[order];
    
  fDataX.clear();
  fDataY.clear();
  
  E_index = fTable.FindEnergy(energy);
  x = fTable.GetEnergy(E_index, order);
  y = fTable.GetRange(E_index, order);
  
  if (x != 0 && x != 0)
    {
      for (UInt_t i=0; i<order; i++)
	{
	  fDataX.push_back(x[i]);
	  fDataY.push_back(y[i]);
	}
      this->PolInterpolate(energy, range, d_range);
      //cout << "Range is: " << range << "  Error is: " << d_range<< " Index: " << E_index<< endl;
      //cout << " Range at index: " << fDataY[2] << " Energy is : " << fDataX[2] << endl;
      return range;
    }
  else
    return -777;
}
//------------------------------
Double_t TSpline::RangeStraggling(Double_t energy)
{
  // first of all we need to find energy in the table:
  UInt_t order = 3;
  Double_t range, d_range;
  Int_t E_index;   //index of energy and range respectively
  Double_t *x = new Double_t[order];
  Double_t *y = new Double_t[order];
    
  fDataX.clear();
  fDataY.clear();
  
  E_index = fTable.FindEnergy(energy);
  x = fTable.GetEnergy(E_index, order);
  y = fTable.GetRangeStraggling(E_index, order);
  
  if (x != 0 && x != 0)
    {
      for (UInt_t i=0; i<order; i++)
	{
	  fDataX.push_back(x[i]);
	  fDataY.push_back(y[i]);
	}
      this->PolInterpolate(energy, range, d_range);
      //cout << "Range is: " << range << "  Error is: " << d_range<< " Index: " << E_index<< endl;
      //cout << " Range at index: " << fDataY[2] << " Energy is : " << fDataX[2] << endl;
      return range;
    }
  else
    return -777; 
}
//------------------------------
Double_t TSpline::StoppingPower(Double_t energy)
{
    // first of all we need to find energy in the table:
  UInt_t order = 3;
  Double_t stopping, d_stopping;
  Int_t E_index;   //index of energy and range respectively
  Double_t *x = new Double_t[order];
  Double_t *y = new Double_t[order];
    
  fDataX.clear();
  fDataY.clear();
  
  E_index = fTable.FindEnergy(energy);
  x = fTable.GetEnergy(E_index, order);
  y = fTable.GetStoppingPower(E_index, order);
  
  if (x != 0 && x != 0)
    {
      for (UInt_t i=0; i<order; i++)
	{
	  fDataX.push_back(x[i]);
	  fDataY.push_back(y[i]);
	}
      this->PolInterpolate(energy, stopping, d_stopping);
      //cout << "Range is: " << range << "  Error is: " << d_range<< " Index: " << E_index<< endl;
      //cout << " Range at index: " << fDataY[2] << " Energy is : " << fDataX[2] << endl;
      return stopping;
    }
  else
    return -777;  

}
//=========================================================================
//
// Class TInteraction which is a collection of all data points
//  
//
//=========================================================================
TInteraction::TInteraction(TFile *f)
{
  fFile = f;
}
//----------
TInteraction::~TInteraction()
{}
//--------
void TInteraction::CreateInteractionTree(UInt_t Zt, const char *data)
{
  // function reads TTables for all A and Z combinations listed in 
  // file data and creates a tree named "element" accroding to Zt passed
  // to the function
  TTree *tree = new TTree(GetElementName(Zt).c_str(),"Data for Range, Range Straggling and Stopping power");
  TTable *table = new TTable();
  Int_t index;
  tree->Branch("data", "TTable", &table, 32000, 99);
  tree->Branch("index", &index, "index/i");
  //===========================
  ifstream file(data);
  UInt_t a,z;
  vector <UInt_t> Index; // a and z of isotopes to be read in
 
  while (!file.eof())
    {
      file >> a >> z;
      Index.push_back(a*100+z);
    }
  file.close();
  sort(Index.begin(), Index.end());   //sorting the whole set of Indeces before filling the tree
  
  for(UInt_t i=0; i<Index.size(); i++)
    {
      a = Index[i] /100;    //a retrieval
      z = Index[i] % 100;   //z retrieval
      char number[3];
      sprintf(number, "%d", a);
      string data_file_name(number);
      data_file_name = "data/" + data_file_name + GetElementName(z) + "_" + GetElementName(Zt) + ".dat"; 
      //data file name constructed   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      // now I am going to fill TTable object with the data in the file:
      table->Init(data_file_name.c_str());
      cout << i << ". Reading file: " << data_file_name  << endl;
      index = Index[i];
      tree->Fill();   //  !!!!  filling the tree   !!!!
    }
  fFile->cd();
  tree->Write();
  return;
}
Double_t TInteraction::EnergyLoss(UInt_t Ap, UInt_t Zp, UInt_t Zt, Double_t thickness, Double_t Energy)
{
  UInt_t index = Ap*100 + Zp;
  Int_t projectile_position;

  TTree *tree = (TTree*)fFile->Get(GetElementName(Zt).c_str());
  if (tree == 0)
    {      
      cerr << "*** Material data not in the file!! ***\n";
      return -777;
    }
  else
    {
      UInt_t IsotopeIndex;
      TTable *table = new TTable;
      tree->SetBranchAddress("index", &IsotopeIndex);
      tree->SetBranchAddress("data", &table);
      Int_t N = (Int_t)tree->GetEntries();  //number of entries in the tree structure
      projectile_position = GetNentry(tree, index);
      if (projectile_position == -1 || projectile_position == N)
	{
	  cerr << "***  Projectile data not in the file! ***\n";
	  return -777;
	}
      else
	{
	  tree->GetEntry(projectile_position);   //retrieving the right table 	  
	  TSpline *spline = new TSpline(table);
	  return spline->EnergyLoss(Energy, thickness);
	}
    }
}
//----------------------------------------
Double_t TInteraction::RangeInMatter(UInt_t Ap, UInt_t Zp, UInt_t Zt, Double_t Energy)
{
  UInt_t index = Ap*100 + Zp;
  Int_t projectile_position;

  TTree *tree = (TTree*)fFile->Get(GetElementName(Zt).c_str());
  if (tree == 0)
    {      
      cerr << "*** Material data not in the file!! ***\n";
      return -777;
    }
  else
    {
      UInt_t IsotopeIndex;
      TTable *table = new TTable;
      tree->SetBranchAddress("index", &IsotopeIndex);
      tree->SetBranchAddress("data", &table);
      Int_t N = (Int_t)tree->GetEntries();  //number of entries in the tree structure
      projectile_position = GetNentry(tree, index);
      if (projectile_position == -1 || projectile_position == N)
	{
	  cerr << "***  Projectile data not in the file! ***\n";
	  return -777;
	}
      else
	{
	  tree->GetEntry(projectile_position);   //retrieving the right table 	  
	  TSpline *spline = new TSpline(table);
	  return spline->RangeInMatter(Energy);
	}
    }
}
//-------------------------------------------
Double_t TInteraction::RangeStraggling(UInt_t Ap, UInt_t Zp, UInt_t Zt, Double_t Energy)
{
    UInt_t index = Ap*100 + Zp;
  Int_t projectile_position;

  TTree *tree = (TTree*)fFile->Get(GetElementName(Zt).c_str());
  if (tree == 0)
    {      
      cerr << "*** Material data not in the file!! ***\n";
      return -777;
    }
  else
    {
      UInt_t IsotopeIndex;
      TTable *table = new TTable;
      tree->SetBranchAddress("index", &IsotopeIndex);
      tree->SetBranchAddress("data", &table);
      Int_t N = (Int_t)tree->GetEntries();  //number of entries in the tree structure
      projectile_position = GetNentry(tree, index);
      if (projectile_position == -1 || projectile_position == N)
	{
	  cerr << "***  Projectile data not in the file! ***\n";
	  return -777;
	}
      else
	{
	  tree->GetEntry(projectile_position);   //retrieving the right table 	  
	  TSpline *spline = new TSpline(table);
	  return spline->RangeStraggling(Energy);
	}
    }
}
//----------------------------------------------------------
Double_t TInteraction::StoppingPower(UInt_t Ap, UInt_t Zp, UInt_t Zt, Double_t Energy)
{
      UInt_t index = Ap*100 + Zp;
  Int_t projectile_position;

  TTree *tree = (TTree*)fFile->Get(GetElementName(Zt).c_str());
  if (tree == 0)
    {      
      cerr << "*** Material data not in the file!! ***\n";
      return -777;
    }
  else
    {
      UInt_t IsotopeIndex;
      TTable *table = new TTable;
      tree->SetBranchAddress("index", &IsotopeIndex);
      tree->SetBranchAddress("data", &table);
      Int_t N = (Int_t)tree->GetEntries();  //number of entries in the tree structure
      projectile_position = GetNentry(tree, index);
      if (projectile_position == -1 || projectile_position == N)
	{
	  cerr << "***  Projectile data not in the file! ***\n";
	  return -777;
	}
      else
	{
	  tree->GetEntry(projectile_position);   //retrieving the right table 	  
	  TSpline *spline = new TSpline(table);
	  return spline->StoppingPower(Energy);
	}
    }
}
//-------------------------------------------------
Double_t TInteraction::EnergyStraggling(UInt_t Ap, UInt_t Zp, UInt_t Zt, Double_t thickness, Double_t Energy)
{
  UInt_t index = Ap*100 + Zp;
  Int_t projectile_position;

  TTree *tree = (TTree*)fFile->Get(GetElementName(Zt).c_str());
  if (tree == 0)
    {      
      cerr << "*** Material data not in the file!! ***\n";
      return -777;
    }
  else
    {
      UInt_t IsotopeIndex;
      TTable *table = new TTable;
      tree->SetBranchAddress("index", &IsotopeIndex);
      tree->SetBranchAddress("data", &table);
      Int_t N = (Int_t)tree->GetEntries();  //number of entries in the tree structure
      projectile_position = GetNentry(tree, index);
      if (projectile_position == -1 || projectile_position == N)
	{
	  cerr << "***  Projectile data not in the file! ***\n";
	  return -777;
	}
      else
	{
	  tree->GetEntry(projectile_position);   //retrieving the right table 	  
	  TSpline *spline = new TSpline(table);
	  Double_t E1 = spline->EnergyLoss(Energy, thickness);
	  if (E1 > 0)
	    {
	      Double_t R0 = spline->RangeStraggling(Energy);
	      Double_t R1 = spline->RangeStraggling(E1);
	      Double_t SP = spline->StoppingPower(E1);
	      if (R0 < R1)
		return 0;
	      else
		{
		  Double_t Omega =  (R0*R0 - R1*R1)*SP*SP;
		  Omega = sqrt(Omega);
		  Omega = Omega/Ap;
		  return Omega;
		}
	    }
	  else
	    return 0;
	}
    }
}
//-----------------------------------------------------------
Int_t GetNentry(TTree *t, UInt_t index)
{  // index is isotope index to find in t TTree
  // function assumes tree is sorted ascending in indeces
  // function return -1 if energy is out of range < less
  // and returns N (Size) if energy is out of range > more
  UInt_t Index;
  t->SetBranchAddress("index", &Index);
  Int_t N = (Int_t)t->GetEntries();
  t->GetEntry(0);
  UInt_t IndexFirst = Index;
  t->GetEntry(N-1);
  UInt_t IndexLast = Index;

  Int_t i_u, i_l, i_m;    //upper and lower limits



  i_u = N;    //initialization of upper limit
  i_l = -1;   // initialization of lower limit
  while(i_u - i_l > 1)
    {
      i_m = (i_u + i_l) >> 1;
      t->GetEntry(i_m);
      if (index >= Index)
	i_l = i_m;
      else
	i_u = i_m;
    }
  if (index == IndexFirst)
    return 0;
  else 
    if (index == IndexLast)
      return N-1;
    else
      {
	t->GetEntry(i_l);
	if (index  == Index)
	  return i_l;
	else 
	  return -1;
      }
}
//-----------------------------------------------------------
string GetElementName(UInt_t z)
{

   switch (z)
    {
    case 0:
      return "n";
      break;
    case 1:
      return "H";
      break;
    case 2:
      return "He";
      break;
    case 3:
      return "Li";
      break;
    case 4:
      return "Be";
      break;  
    case 5:
      return "B";
      break;
    case 6:
      return "C";
      break;
    case 7:
      return "N";
      break;
    case 8:
      return "O";
      break;
    case 9:
      return "F";
      break;
    case 10:
      return "Ne";
      break;
    case 11:
      return "Na";
      break;
    case 12:
      return "Mg";
      break;
    case 13:
      return "Al";
      break;
    case 14:
      return "Si";
      break;
    case 15:
      return "P";
      break;
    case 16:
      return "S";
      break;
    case 17:
      return "Cl";
      break;
    case 18:
      return "Ar";
      break;
    case 19:
      return "K";
      break;
    case 20:
      return "Ca";
      break;
    case 21:
      return "Sc";
      break;
    case 22:
      return "Ti";
      break;
    case 23:
      return "V";
      break;
    case 24:
      return "Cr";
      break;
    case 25:
      return "Mn";
      break;
    case 26:
      return "Fe";
      break;
    case 27:
      return "Co";
      break;
    case 28:
      return "Ni";
      break;
    case 29:
      return "Cu";
      break;
    case 30:
      return "Zn";
      break;
    case 31:
      return "Ga";
      break;
    case 32:
      return "Ge";
      break;
    case 33:
      return "As";
      break;
    case 34:
      return "Se";
      break;
    case 35:
      return "Br";
      break;
    case 36:
      return "Kr";
      break;
    case 37:
      return "Rb";
      break;
    case 38:
      return "Sr";
      break;
    case 39:
      return "Y";
      break;
    case 40:
      return "Zr";
      break;
    case 41:
      return "Nb";
      break;
    case 42:
      return "Mo";
      break;
    case 43:
      return "Tc";
      break;
    case 44:
      return "Ru";
      break;
    case 45:
      return "Rh";
      break;
    case 46:
      return "Pd";
      break;
    case 47:
      return "Ag";
      break;
    case 48:
      return "Cd";
      break;
    case 49:
      return "In";
      break;
    case 50:
      return "Sn";
      break;
    case 51:
      return "Sb";
      break;
    case 52:
      return "Te";
      break;
    case 53:
      return "I";
      break;
    case 54:
      return "Xe";
      break;
    case 55:
      return "Cs";
      break;
    case 56:
      return "Ba";
      break;
    case 57:
      return "La";
      break;
    case 58:
      return "Ce";
      break;
    case 59:
      return "Pr";
      break;
    case 60:
      return "Nd";
      break;
    case 61:
      return "Pm";
      break;
    case 62:
      return "Sm";
      break;
    case 63:
      return "Eu";
      break;
    case 64:
      return "Gd";
      break;
    case 65:
      return "Tb";
      break;
    case 66:
      return "Dy";
      break;
    case 67:
      return "Ho";
      break;
    case 68:
      return "Er";
      break;
    case 69:
      return "Tm";
      break;
    case 70:
      return "Yb";
      break;
    case 71:
      return "Lu";
      break;
    case 72:
      return "Hf";
      break;
    case 73:
      return "Ta";
      break;
    case 74:
      return "W";
      break;
    case 75:
      return "Re";
      break;
    case 76:
      return "Os";
      break;
    case 77:
      return "Ir";
      break;
    case 78:
      return "La";
      break;
    case 79:
      return "Au";
      break;
    case 80:
      return "Hg";
      break;
    case 81:
      return "Tl";
      break;
    case 82:
      return "Pb";
      break;
    case 83:
      return "Bi";
      break;
    case 84:
      return "Po";
      break;
    case 85:
      return "At";
      break;
    case 86:
      return "Rn";
      break;
    case 87:
      return "Fr";
      break;
    case 88:
      return "Ra";
      break;
    case 89:
      return "Ac";
      break;
    case 90:
      return "Th";
      break;
    case 91:
      return "Pa";
      break;
    case 92:
      return "U";
      break;
    case 200:
      return "CH2";   //polyethylene target as Z=200!!
      break;
    default:
      return "N/A";
      break;

    }
}
